module io(in,clk,clrn,A,B,C,D,E,F,G,H,TEST);
input in,clk,clrn;
output A,B,C,D,E,F,G,H,TEST;
reg SA,SB,SC,SD,SE,SF,SG,SH; // shift reg
reg OA,OB,OC,OD,OE,OF,OG,OH; // output reg
reg t;

always@(posedge clk)
	if(clrn)
	begin
	// 74164 shift reg
		begin
		SA<=in;
		SB<=SA;
		SC<=SB;
		SD<=SC;
		SE<=SD;
		SF<=SE;
		SG<=SF;
		SH<=SG;
		end

	// t flip flop
	if ((SA==1 && SB==0 && SC==0 && SD==0 && SE==0 && SF==0 && SG==0 && SH==1) || (SA==0 && SB==1 && SC==1 && SD==1 && SE==1 && SF==1 && SG==1 && SH==0))
		t=~t;
	end


always@(posedge clk)
	if(clrn)
	if(t) // output reg
	begin
		OA<=SA;
		OB<=SB;
		OC<=SC;
		OD<=SD;
		OE<=SE;
		OF<=SF;
		OG<=SG;
		OH<=SH;
	end

assign A=OA;
assign B=OB;
assign C=OC;
assign D=OD;
assign E=OE;
assign F=OF;
assign G=OG;
assign H=OH;
assign TEST=t;

endmodule
